@echo off
SETLOCAL
REM This batch file can be used to build the target directories "dist" and "debug" one layer
REM up from here where the release and debug binaries will be compiled to.

SET AA_DIR=..
SET AA_BUILD_DIR=%AA_DIR%\build\tmp
mkdir %AA_BUILD_DIR%\tmp_124
rmdir %AA_BUILD_DIR%\tmp_124

SET /P MAJOR_VERSION= < %AA_DIR%\major_version
SET /P MINOR_VERSION_TPL= < %AA_DIR%\minor_version
SET HELP_FILE=%AA_BUILD_DIR%\help-%RANDOM%.txt

echo.
echo *** checking python
call python.bat -C 1>nul
SET HAVE_PYTHON=%ERRORLEVEL%

IF "%HAVE_PYTHON%"=="0" (
	echo. - Detected python
	call python.bat -c "import datetime; print datetime.date.today().strftime('%%%%Y%%%%m%%%%d')" > %HELP_FILE%
	SET /P DATESTAMP= < %HELP_FILE%
) else (
	echo !!! PYTHON not found
	SET DATESTAMP=SVN
)

SET MINOR_VERSION=%MINOR_VERSION_TPL:DATE=%%DATESTAMP%

IF EXIST %AA_DIR%\.svn (
	echo.
	echo *** reading SVN repository and revision
	SET URL=
	SET REV=
	FOR /F "tokens=1,2 delims=,>=< " %%i in (%AA_DIR%\.svn\entries) do (
		IF *%%i*==*url* (
			SET URL=%%~j
		)
	)
	FOR /F "tokens=1,2 delims=,>=</ " %%i in (%AA_DIR%\.svn\entries) do (
		IF *%%i*==*revision* (
			SET REV=%%~j
		)
	)
)

	REM Close IF block to copy URL and REV to outer scope

	REM uncomment the following URLs to test various cases
	REM trunk
	REM SET URL=https://svn.sourceforge.net/svnroot/armagetronad/armagetronad/trunk/armagetronad
	REM branch 0.4
	REM SET URL=https://svn.sourceforge.net/svnroot/armagetronad/armagetronad/branches/0.4/armagetronad

	REM tag 0.2.8.2
	REM SET URL=https://svn.sourceforge.net/svnroot/armagetronad/armagetronad/tags/0.2.8.2/armagetronad

IF EXIST %AA_DIR%\.svn (
	echo. - SVN: %URL%
	echo. - SVN: %REV%
	FOR /F " tokens=5,6,7 delims=/ " %%i in ("%URL%") do (
		IF *%%j*==*tags* (
			SET MAJOR_VERSION=%%k
			SET MINOR_VERSION=
		) else (
			IF *%%j*==*branches* (
				SET MAJOR_VERSION=%%k
			)
			SET MINOR_VERSION=_alpha%REV%
		)
	)
)
echo.
echo.

IF EXIST %AA_DIR%\.bzr (
	bzr revno > %HELP_FILE%
	SET /P REV= < %HELP_FILE%
)

IF EXIST %AA_DIR%\.git (
    git rev-list --count HEAD > %HELP_FILE%
	SET /P REV= < %HELP_FILE%
)

echo %REV%
IF NOT DEFINED REV SET REV=%DATESTAMP:~4%

echo *%MAJOR_VERSION%*
echo *%DATESTAMP%*
echo *%DATESTAMP:~4%*
echo *%HELP_FILE%*
echo *** generating tTrueVersion.h...
echo #define TRUE_ARMAGETRONAD_MAJOR_VERSION 1,%MAJOR_VERSION:.=%,0,%REV% > %HELP_FILE%

echo #define TRUE_ARMAGETRONAD_MINOR_VERSION %MINOR_VERSION% >> %HELP_FILE%

echo #define TRUE_ARMAGETRONAD_VERSION "%MAJOR_VERSION%%MINOR_VERSION%" >> %HELP_FILE%

echo #define TRUE_ARMAGETRONAD_BUILDDATE "%DATESTAMP%" >> %HELP_FILE%

echo. - Detected: Armagetron Advanced %MAJOR_VERSION%%MINOR_VERSION%
echo.
echo.
copy %HELP_FILE% %AA_DIR%\src\tTrueVersion.h

:exit
IF NOT "%HAVE_PYTHON%"=="0" (
	echo ************************************************************************
	echo *** WARNING: Python was not found	***
	echo ************************************************************************
	echo *** Please check your python configuration. You can set the path for ***
	echo *** python in "build_codeblocks\python.bat"	***
	echo ************************************************************************
	echo *** If python is not available on your machine, you should edit	***
	echo ***		%AA_DIR%\src\version.h	***
	echo *** Replace SVN by the current date (format: YYYYMMDD e.g. 20061231^) ***
	echo ************************************************************************
)
echo.
del %HELP_FILE% /Q /F
echo.
echo.
echo done!

pause
:return
